import 'reflect-metadata'
import {Service} from "typedi"
import {IUser} from "../types"
import {db} from "../includes"
import {fillIUser} from "../helpers/entity-fill"

@Service()
export class UserModel {
    async insertUser(user: IUser) {
        await db.query('insert into users (username,realName,role) values(?,?,?) ' +
            'ON DUPLICATE KEY UPDATE username=username', [
            user.username, user.realName, user.role
        ])
    }

    async findUserByUsername(username: string) {
        let user = await db.query('select * from users where username=?', [username])
        if (!user.length) {
            return null
        }
        return fillIUser(user[0])
    }

    async findUserById(id: number) {
        let user = await db.query('select * from users where id=?', [id])
        if (!user.length) {
            return null
        }
        return fillIUser(user[0])
    }
}
