export interface IResultJson {
    status: boolean,
    data: any
}

export type TUserRole = 1 | 2

export interface IUser {
    id?: number,
    username: string,
    realName: string,
    role: TUserRole
}


export interface JWTUserPayload {
    id: number,
    role: TUserRole
}

export type TPostPending = 1
export type TPostPublished = 2
export type TPostRejected = 3
export type TPostStatus = TPostPending | TPostPublished | TPostRejected

export interface IPost {
    id?: number,
    userId: number,
    content: string,
    image: string,
    status: TPostStatus,
    time: number
}
